#open"syntaxe_commune";;
#open"syntaxe_miniml";;

let rec separe l = match l with
   []          -> ([],[])
 | (a,b)::rest -> let (la,lb) = separe rest in (a::la,b::lb)
;;

let rec trad_expr_miniml = function 
   MLApp (e,e1)    -> App (trad_expr_miniml e,trad_expr_miniml e1)
 | MLFun (id,e)    -> Abs (id,trad_expr_miniml e)
 | MLVar id        -> Var id
 | MLCst cst       -> Cst cst
 | MLIf (e0,e1,e2) ->
       	 If (trad_expr_miniml e0,trad_expr_miniml e1,trad_expr_miniml e2)
 | MLSet (id,e)    -> Set (id,trad_expr_miniml e)
 | MLLetIn (l,e)   ->
       	 let (idl,el) = separe l in
       	 LetIn (idl,map trad_expr_miniml el,trad_expr_miniml e)
 | MLLetRecIn (l,e) ->
       	 let (idl,el) = separe l in
         LetRecIn (idl,map trad_expr_miniml el,trad_expr_miniml e)
 | MLSeq (l,e)    ->
       	 let idl = map (fun _  -> nouveau_nom ()) l in
         LetIn (idl,map trad_expr_miniml l,trad_expr_miniml e)
 | MLPrim prim      -> Prim prim
;;

let rec trad_pgm_miniml = function
   [] -> Cst (Int 1)
 | [MLExpr e] -> trad_expr_miniml e
 | (MLExpr e):: reste ->
         LetIn ([nouveau_nom ()],[trad_expr_miniml e],trad_pgm_miniml reste)
 | (MLLet l) :: reste -> 
       	 let (idl,el) = separe l in
       	 LetIn (idl,map trad_expr_miniml el,trad_pgm_miniml reste)
 | (MLLetRec l):: reste ->
       	 let (idl,el) = separe l in
       	 LetRecIn (idl,map trad_expr_miniml el,trad_pgm_miniml reste)
;;

let ajoute_init_env corps = 
  LetIn (["print"],[Abs ("",Prim Affiche)],corps)
;;

let traduit_miniml l =
  ajoute_init_env (trad_pgm_miniml l)
;;

